#!/bin/bash

host="127.0.0.1"
port="8765"
cpy="true"

function helpme()
{
	echo "Sposob uzycia:"
	echo "$0 [-P port] [-H host] [-n] [prefiks]"
	echo "Opcja -n oznacza, że plik ~/.ivolektor.cfg nie zostanie nadpisany"
	echo "a wykryte głosy Ivony zostaną zapisane w _ivolektor.cfg"
}


while getopts "hnH:P:" opt; do
	case "$opt" in
	"H")	host="$OPTARG";;
	"P")	port="$OPTARG";;
	"n")	cpy="false";;
	*)	helpme "$0"; exit 1;;
	esac
done
shift $((OPTIND-1))
local="false"
if [ "$host" == "127.0.0.1" ] || [ "$host" == "localhost" ] ; then
	local="true"
fi
if test "$1" != "" ; then
	sapidir="$1"
	if ! echo $sapidir | grep "^/" >/dev/null 2>/dev/null ; then
		if ! echo $sapidir | grep '^\.' >/dev/null ; then
			sapidir=".$sapidir"
		fi
		sapidir="$HOME/$sapidir"
	fi
elif test "$WINEPREFIX" != "" ; then
	sapidir="$WINEPREFIX"
else
	sapidir=~/.wine
fi

pport=9800

export WINEPREFIX="$sapidir"
if [ "$local" == "true" ] ; then
	wine \
		open-sapi/bin/tclsh85.exe \
		open-sapi/server/opensapi-srv.tcl --port $pport --timeout 20 >/dev/null 2>&1 &
	sleep 10
else
	pport=$port
fi
echo getEngine | nc $host $pport | \
 awk -f cnf.awk -v dy=`pwd` -v w="$sapidir" -F: \
 -v host="$host" -v port="$port" -v loc="$local" > _ivolektor.cfg
if [ "$cpy" == "true" ] ; then
	if [ -f ~/.ivolektor.cfg ] ; then
		cp ~/.ivolektor.cfg ~/.ivolektor.cfg.bak
		echo "Plik ~ivolektor.cfg zostal skopiowany do ~/.ivolektor.cfg.bak"
	fi
	cp _ivolektor.cfg ~/.ivolektor.cfg
else
	echo "Wykryte głosy Ivony:"
	echo
	cat _ivolektor.cfg
fi
if [ "$local" == "true" ] ; then
	echo killServer | nc localhost $port
fi

